import struct
from bluepy.btle import *
import binascii
import threading
import requests
import time
import math

savedatas = []

def is_fall(acc_x, acc_y, acc_z, gyro_x, gyro_y, gyro_z):
    if acc_y < -1 and (abs(acc_x) > 1 or abs(acc_z) > 1):
        return True
    return False

# Callback function to convert hexadecimal to decimal
def com(temp):
    dec = int(temp, 16)
    if dec > 32768:
        dec = ((dec ^ 0xFFFF) + 1) * -1
    dec = dec * 2 / 32768
    return dec

# Delegate class for handling notifications
class MyDelegate(DefaultDelegate):
    def __init__(self, data):
        DefaultDelegate.__init__(self)
        self.data = data

    def handleNotification(self, cHandle, data):
        print('getting data')

        t1 = binascii.hexlify(data)[0:4]
        t2 = binascii.hexlify(data)[4:8]
        t3 = binascii.hexlify(data)[8:12]
        t4 = binascii.hexlify(data)[12:16]
        t5 = binascii.hexlify(data)[16:20]
        t6 = binascii.hexlify(data)[20:24]

        acc_x = com(t1)
        acc_y = com(t2)
        acc_z = com(t3)
        
        gyro_x = com(t4) * 500
        gyro_y = com(t5) * 500
        gyro_z = com(t6) * 500

        #print("Acc X = ", acc_x)
        #print("Acc Y = ", acc_y)
        #print("Acc Z = ", acc_z)
        #print("Gyro X = ", com(t4) * 500)
        #print("Gyro Y = ", com(t5) * 500)
        #print("Gyro Z = ", com(t6) * 500)
        
        savedatas.append([acc_x,acc_y,acc_z])
        
        did = is_fall(acc_x, acc_y, acc_z, gyro_x, gyro_y, gyro_z)
            
        if did:
            t = time.time()
            tt = time.localtime(t)
            print("fall down !!!")
            t = time.time()
            t1 = time.localtime(t)
            t2 = time.strftime('%Y/%m/%d %H:%M:%S',t1)
            url = 'https://notify-api.line.me/api/notify'
            token = '1iMYOVPvKaRVmZ8vvADN4L4PCzgg2TMK22GeGgDcTMP'
            headers = {
                'Authorization': 'Bearer ' + token    # 設定權杖
            }
            data = {
                'message':'\n⚠️⚠️⚠️⚠️⚠️⚠️⚠️⚠️⚠️⚠️\n' + time.strftime('%Y/%m/%d %H:%M:%S',tt) + '\n系統檢測到跌倒，請立即採取行動!\n⚠️⚠️⚠️⚠️⚠️⚠️⚠️⚠️⚠️⚠ '     # 設定要發送的訊息
            }
            data = requests.post(url, headers=headers, data=data)   # 使用 POST 方法


                    # Append accelerometer values to the data list
        self.data.append((acc_x, acc_y, acc_z))

##############################################################
# Scan boardcast
scanner = Scanner()
devices = scanner.scan(10.0)

for dev in devices:
    print("Device %s (%s), RSSI=%d dB" % (dev.addr, dev.addrType, dev.rssi))
    for (adtype, desc, value) in dev.getScanData():
        print("  %s = %s" % (desc, value))

print("D7:71:E4:25:4D:F9")
address = "D7:71:E4:25:4D:F9"
###############################################################

# Connect to device
per = Peripheral(address, "random")

# Wait for ENTER key press to start printing

print('-------------start------------\n-                            -\n-                            -\n-------------start------------')
try:
    services_dic = per.getServices()  # Get all services
    for service in services_dic:
        print("service uuid: ", service.uuid)  # Get service's uuid
        charac_dic = service.getCharacteristics()  # Get all characteristics
        for charac in charac_dic:
            print("characteristics uuid: ", charac.uuid)  # Get characteristic's uuid
            print("handle: ", charac.getHandle())  # Get characteristic's handle

    # Create a list to store accelerometer data
    data = []

    # Set callback for notifications
    per.setDelegate(MyDelegate(data))

    # Enable notification
    setup_data = b"\x01\x00"  # Data for enabling notification
    led_data = b"\x37\x01\x01"  # Data for LED

    per.writeCharacteristic(45, led_data, withResponse=True)  # Write LED characteristic
    per.writeCharacteristic(23, setup_data, withResponse=True)  # Write sensor characteristic

    # Wait for notifications
    while True:
        if per.waitForNotifications(5.0):
            continue
finally:
    per.disconnect()
    with open('data.json',"w") as f:
        f.write(str(savedatas))
